#!/usr/bin/perl

# Perl program to measure the percent of
# coefficients by each radius within a
# subimage of size n x n
#
# Input: the value of n
# Output: A table of radius and total percent 
#         of cofficiente inside a circle of this radius
#
# Use the PERL program "mask_dct.pl" to
# calculate the mask 
# 
# Fraga July, 11, 2001

die "Args: n_value\n" if ! $ARGV[0];

$n = $ARGV[0];

print "#  radius  number_coefficients  %\n";

for ( $r=1; $r<=$n; $r+=0.2 ) {
	$R2 = $r * $r;
	$n_coef = 0;
	for ( $i=0; $i<$n; $i++ ) {
		$r1 = $i * $i;
		for ( $j=0; $j<$n; $j++ ) {
			$r2 = $j * $j;
			$f = $r1 + $r2 - $R2;
			if ( $f <= 0 ) { 
				$n_coef++;
			}
		}
	}
	$percent = $n_coef / ( $n * $n );
	printf "%2.1f %2d %f\n", $r,  $n_coef,  $percent;
}
$percent = $n*$n;
print "# Total number of coeffcientsp = $percent\n";

