/**
	Program to reduce to sixteen grey tones
	an image in 256 grey tones
	(it use histogram equalization technique)
	Input image must be in TIFF format

	Fraga, Jun 29, 2001

	Modification for method 1 : truncate to first 4 bytes
	Modification for method 2 : Improved Grey Scale
	Fraga, Jun 30, 2001 
	
**/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "matrix.h"
#include "tiff.h"

MATRIX * bit_plane( MATRIX * IN ) 
{
	MATRIX *OUT;
	int i, j;
	byte *pin, *pout, aux;

	OUT = matrix_allocate( 100, 100, 1 );

	for ( i=0; i<50; i++ ) {
		pout = (byte *)OUT->ptr[i];

		for ( j=0; j<100; j++ )  pout[j] = 0;
	}
	for ( i=50; i<100; i++ ) {
		pout = (byte *)OUT->ptr[i];

		for ( j=0; j<100; j++ )  pout[j] = 1;
	}

	return OUT;
}

int do_work( char *namein, int howdo ) 
{
	MATRIX *IN, *EQ;
	FILEINFO finfo;
	int i, j;
	byte *iptr;
	

	EQ = bit_plane( IN );

	EQ->type=1;
	if ( write_tiff( EQ, "plane1.tif" ) != GOOD_WRITE )  
        return -1;

	matrix_free( EQ );

	return 0;
}

int main( int argc, char *argv[] )
{
	char namein[32];
	int bit = 0;

	if ( argc < 3 ) { 
		fprintf( stderr, "Use: %s image.tif bit\n", argv[0] );
		return -1;
	}

	strncpy( namein, argv[1], 32 );
	bit = atoi ( argv[2] );

	if ( do_work( namein, bit ) >= 0 ) {
		fprintf( stderr, "OK!!!\n" );
		return 0;
	}
	else {
		fprintf( stderr, "ERROR: Something is wrong!!!\n" );
		exit(1);
	}
	return 0;
}
